/*
 * TRPCLatSubDataWrapper.h
 *
 *  Created on: Feb 14, 2024
 *      Author: yasmine
 */

#ifndef TRPCLATSubDataWrapper_WRAPPER_HEADER_H
#define TRPCLATSubDataWrapper_WRAPPER_HEADER_H

#include "dpc_trpc_lat/executable.h"
#include "sub/SubDataWrapper.h"

/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class VED2TRPCLat_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        dpc::VED4DPC* _ved_to_trpclat = nullptr;
	public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _ved_to_trpclat = (dpc::VED4DPC*)ptr->Get();
        }
        void GetData(dpc::VED4DPC &data){
            if(_ved_to_trpclat)
                data = *(_ved_to_trpclat);
        }
    
}; 
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class DM2TRPCLat_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        dpc::Decision4Lat* _dm_to_trpclat = nullptr;
    public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _dm_to_trpclat = (dpc::Decision4Lat*)ptr->Get();
        }
        void GetData(dpc::Decision4Lat &data){
            if(_dm_to_trpclat)    
                data = *(_dm_to_trpclat);
            std::cout << "@@@@@ LAT SUB data.ba_ref_line_c0: "<< data.ba_ref_line_c0 <<"\n";
        }
}; 
/*-------------------------------------------------------------------------------------------------------------------------*/
template <typename DataType>
class CAN2Lat_SubDataWrapper :  public SubDataWrapper<DataType>
{
    private:
        CAN2SWC* _trpclat_data_from_CAN = nullptr;
	public:
        void Process(ara::com::SamplePtr<DataType const>* ptr) override
        {
            _trpclat_data_from_CAN = (CAN2SWC*)ptr->Get();
        }
        void GetData(CAN2SWC &data){
            if(_trpclat_data_from_CAN)
                data = *(_trpclat_data_from_CAN);
        }
};
#endif /* TRPCLATSubDataWrapper_WRAPPER_HEADER_H */
